"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrderEntity = exports.OrderItem = void 0;
const cerialize_1 = require("cerialize");
const class_validator_1 = require("class-validator");
const fraction_js_1 = __importDefault(require("fraction.js"));
const base_1 = require("./base");
const cerialize_2 = require("../../utils/cerialize");
class OrderItem {
    constructor() {
        this.originalPrice = new fraction_js_1.default(0);
        this.price = new fraction_js_1.default(0);
        this.priceInclTax = new fraction_js_1.default(0);
        this.rowTotal = new fraction_js_1.default(0);
        this.rowTotalInclTax = new fraction_js_1.default(0);
        this.rowTotalWithDiscount = new fraction_js_1.default(0);
        this.taxAmount = new fraction_js_1.default(0);
        this.taxBeforeDiscount = new fraction_js_1.default(0);
        this.taxPercent = new fraction_js_1.default(0);
        this.taxInvoiced = new fraction_js_1.default(0);
        this.taxRefunded = new fraction_js_1.default(0);
        this.discountAmount = new fraction_js_1.default(0);
        this.discountPercent = new fraction_js_1.default(0);
        this.discountTaxCompensationAmount = new fraction_js_1.default(0);
        this.qty = 0;
        this.qtyCanceled = 0;
        this.qtyInvoiced = 0;
        this.qtyOrdered = 0;
        this.qtyRefunded = 0;
        this.qtyShipped = 0;
        this.paymentGatewayMdr = new fraction_js_1.default(0);
    }
}
__decorate([
    cerialize_1.autoserializeAs('itemId')
], OrderItem.prototype, "itemId", void 0);
__decorate([
    cerialize_1.autoserializeAs('orderId')
], OrderItem.prototype, "orderId", void 0);
__decorate([
    class_validator_1.IsNotEmpty(),
    cerialize_1.autoserializeAs('sku')
], OrderItem.prototype, "sku", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'originalPrice')
], OrderItem.prototype, "originalPrice", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'price')
], OrderItem.prototype, "price", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'priceInclTax')
], OrderItem.prototype, "priceInclTax", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'rowTotal')
], OrderItem.prototype, "rowTotal", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'rowTotalInclTax')
], OrderItem.prototype, "rowTotalInclTax", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'rowTotalWithDiscount')
], OrderItem.prototype, "rowTotalWithDiscount", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'taxAmount')
], OrderItem.prototype, "taxAmount", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'taxBeforeDiscount')
], OrderItem.prototype, "taxBeforeDiscount", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'taxPercent')
], OrderItem.prototype, "taxPercent", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'taxInvoiced')
], OrderItem.prototype, "taxInvoiced", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'taxRefunded')
], OrderItem.prototype, "taxRefunded", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'discountAmount')
], OrderItem.prototype, "discountAmount", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'discountPercent')
], OrderItem.prototype, "discountPercent", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'discountTaxCompensationAmount')
], OrderItem.prototype, "discountTaxCompensationAmount", void 0);
__decorate([
    cerialize_1.autoserializeAs('name')
], OrderItem.prototype, "name", void 0);
__decorate([
    cerialize_1.autoserializeAs('qty')
], OrderItem.prototype, "qty", void 0);
__decorate([
    cerialize_1.autoserializeAs('qtyCanceled')
], OrderItem.prototype, "qtyCanceled", void 0);
__decorate([
    cerialize_1.autoserializeAs('qtyInvoiced')
], OrderItem.prototype, "qtyInvoiced", void 0);
__decorate([
    cerialize_1.autoserializeAs('qtyOrdered')
], OrderItem.prototype, "qtyOrdered", void 0);
__decorate([
    cerialize_1.autoserializeAs('qtyRefunded')
], OrderItem.prototype, "qtyRefunded", void 0);
__decorate([
    cerialize_1.autoserializeAs('qtyShipped')
], OrderItem.prototype, "qtyShipped", void 0);
__decorate([
    cerialize_1.autoserializeAs('refItemId')
], OrderItem.prototype, "refItemId", void 0);
__decorate([
    cerialize_1.autoserializeAs('rawData')
], OrderItem.prototype, "rawData", void 0);
__decorate([
    cerialize_1.autoserializeAs('weight')
], OrderItem.prototype, "weight", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.DateSerializer, 'createdAt')
], OrderItem.prototype, "createdAt", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.DateSerializer, 'updatedAt')
], OrderItem.prototype, "updatedAt", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'paymentGatewayMdr')
], OrderItem.prototype, "paymentGatewayMdr", void 0);
exports.OrderItem = OrderItem;
let OrderEntity = class OrderEntity extends base_1.DynamoBaseEntity {
    constructor() {
        super(...arguments);
        this.orderToken = '';
        this.appliedRuleIds = [];
        this.appliedRules = [];
        this.status = 'new';
        this.isArchived = false;
        this.grandTotal = new fraction_js_1.default(0);
        this.subtotal = new fraction_js_1.default(0);
        this.subtotalInclTax = new fraction_js_1.default(0);
        this.subtotalInvoiced = new fraction_js_1.default(0);
        this.subtotalCanceled = new fraction_js_1.default(0);
        this.subtotalRefunded = new fraction_js_1.default(0);
        this.discountAmount = new fraction_js_1.default(0);
        this.discountInvoiced = new fraction_js_1.default(0);
        this.discountRefunded = new fraction_js_1.default(0);
        this.taxAmount = new fraction_js_1.default(0);
        this.taxCanceled = new fraction_js_1.default(0);
        this.taxInvoiced = new fraction_js_1.default(0);
        this.taxRefunded = new fraction_js_1.default(0);
        this.discountTaxCompensationAmount = new fraction_js_1.default(0);
        this.customShipping = new fraction_js_1.default(0);
        this.specialDiscountAmount = new fraction_js_1.default(0);
        this.totalProduct = 0;
        this.totalQty = 0;
        this.totalCanceled = 0;
        this.totalInvoiced = 0;
        this.totalRefunded = 0;
        this.paymentMethodId = 0;
        this.shippingAmount = new fraction_js_1.default(0);
        this.shippingDiscountAmount = new fraction_js_1.default(0);
        this.shippingInclTax = new fraction_js_1.default(0);
        this.shippingTaxAmount = new fraction_js_1.default(0);
        this.shippingMethodDetail = '';
        this.globalToOrderRate = new fraction_js_1.default(0);
        this.chainStoreId = '';
        this.shippingDiscountTaxCompensationAmount = 0;
        this.totalShippingAmount = 0;
        this.items = [];
    }
};
__decorate([
    class_validator_1.IsNotEmpty(),
    cerialize_1.autoserializeAs('orderId')
], OrderEntity.prototype, "orderId", void 0);
__decorate([
    class_validator_1.IsNotEmpty(),
    cerialize_1.autoserializeAs('storeId')
], OrderEntity.prototype, "storeId", void 0);
__decorate([
    cerialize_1.autoserializeAs('cartId')
], OrderEntity.prototype, "cartId", void 0);
__decorate([
    cerialize_1.autoserializeAs('mapOrderId')
], OrderEntity.prototype, "mapOrderId", void 0);
__decorate([
    cerialize_1.autoserializeAs('orderToken')
], OrderEntity.prototype, "orderToken", void 0);
__decorate([
    cerialize_1.autoserializeAs('appliedRuleIds')
], OrderEntity.prototype, "appliedRuleIds", void 0);
__decorate([
    cerialize_1.autoserializeAs('couponCode')
], OrderEntity.prototype, "couponCode", void 0);
__decorate([
    cerialize_1.autoserializeAs('appliedRules')
], OrderEntity.prototype, "appliedRules", void 0);
__decorate([
    cerialize_1.autoserializeAs('couponRuleName')
], OrderEntity.prototype, "couponRuleName", void 0);
__decorate([
    cerialize_1.autoserializeAs('status')
], OrderEntity.prototype, "status", void 0);
__decorate([
    cerialize_1.autoserializeAs('customerId')
], OrderEntity.prototype, "customerId", void 0);
__decorate([
    class_validator_1.IsNotEmpty(),
    cerialize_1.autoserializeAs('name')
], OrderEntity.prototype, "name", void 0);
__decorate([
    class_validator_1.IsEmail(),
    cerialize_1.autoserializeAs('email')
], OrderEntity.prototype, "email", void 0);
__decorate([
    cerialize_1.autoserializeAs('isArchived')
], OrderEntity.prototype, "isArchived", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'grandTotal')
], OrderEntity.prototype, "grandTotal", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'subtotal')
], OrderEntity.prototype, "subtotal", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'subtotalInclTax')
], OrderEntity.prototype, "subtotalInclTax", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'subtotalInvoiced')
], OrderEntity.prototype, "subtotalInvoiced", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'subtotalCanceled')
], OrderEntity.prototype, "subtotalCanceled", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'subtotalRefunded')
], OrderEntity.prototype, "subtotalRefunded", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'discountAmount')
], OrderEntity.prototype, "discountAmount", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'discountInvoiced')
], OrderEntity.prototype, "discountInvoiced", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'discountRefunded')
], OrderEntity.prototype, "discountRefunded", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'taxAmount')
], OrderEntity.prototype, "taxAmount", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'taxCanceled')
], OrderEntity.prototype, "taxCanceled", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'taxInvoiced')
], OrderEntity.prototype, "taxInvoiced", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'taxRefunded')
], OrderEntity.prototype, "taxRefunded", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'discountTaxCompensationAmount')
], OrderEntity.prototype, "discountTaxCompensationAmount", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'customShipping')
], OrderEntity.prototype, "customShipping", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'specialDiscountAmount')
], OrderEntity.prototype, "specialDiscountAmount", void 0);
__decorate([
    cerialize_1.autoserializeAs('totalProducts')
], OrderEntity.prototype, "totalProduct", void 0);
__decorate([
    cerialize_1.autoserializeAs('totalQty')
], OrderEntity.prototype, "totalQty", void 0);
__decorate([
    cerialize_1.autoserializeAs('totalCanceled')
], OrderEntity.prototype, "totalCanceled", void 0);
__decorate([
    cerialize_1.autoserializeAs('totalInvoiced')
], OrderEntity.prototype, "totalInvoiced", void 0);
__decorate([
    cerialize_1.autoserializeAs('totalRefunded')
], OrderEntity.prototype, "totalRefunded", void 0);
__decorate([
    cerialize_1.autoserializeAs('paymentMethodId')
], OrderEntity.prototype, "paymentMethodId", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'shippingAmount')
], OrderEntity.prototype, "shippingAmount", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'shippingDiscountAmount')
], OrderEntity.prototype, "shippingDiscountAmount", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'shippingInclTax')
], OrderEntity.prototype, "shippingInclTax", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'shippingTaxAmount')
], OrderEntity.prototype, "shippingTaxAmount", void 0);
__decorate([
    cerialize_1.autoserializeAs('shippingMethodId')
], OrderEntity.prototype, "shippingMethodId", void 0);
__decorate([
    cerialize_1.autoserializeAs('shippingMethodName')
], OrderEntity.prototype, "shippingMethodName", void 0);
__decorate([
    cerialize_1.autoserializeAs('shippingMethodDetail')
], OrderEntity.prototype, "shippingMethodDetail", void 0);
__decorate([
    cerialize_1.autoserializeAs('globalCurrencyCode')
], OrderEntity.prototype, "globalCurrencyCode", void 0);
__decorate([
    cerialize_1.autoserializeAs('orderCurrencyCode')
], OrderEntity.prototype, "orderCurrencyCode", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.FractionSerializer, 'globalToOrderRate')
], OrderEntity.prototype, "globalToOrderRate", void 0);
__decorate([
    cerialize_1.autoserializeAs('weight')
], OrderEntity.prototype, "weight", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.DateSerializer, 'expiredAt')
], OrderEntity.prototype, "expiredAt", void 0);
__decorate([
    cerialize_1.autoserializeAs('chainStoreId')
], OrderEntity.prototype, "chainStoreId", void 0);
__decorate([
    cerialize_1.autoserializeAs('chainStoreDetail')
], OrderEntity.prototype, "chainStoreDetail", void 0);
__decorate([
    cerialize_1.autoserializeAs('channelId')
], OrderEntity.prototype, "channelId", void 0);
__decorate([
    cerialize_1.autoserializeAs('orderRef')
], OrderEntity.prototype, "orderRef", void 0);
__decorate([
    cerialize_1.autoserializeAs('rawData')
], OrderEntity.prototype, "rawData", void 0);
__decorate([
    cerialize_1.autoserializeAs('remark')
], OrderEntity.prototype, "remark", void 0);
__decorate([
    cerialize_1.autoserializeAs('isGrandTotalOverrode')
], OrderEntity.prototype, "isGrandTotalOverrode", void 0);
__decorate([
    cerialize_1.autoserializeAs('meta')
], OrderEntity.prototype, "meta", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.DateSerializer, 'lastPrinted')
], OrderEntity.prototype, "lastPrinte", void 0);
__decorate([
    cerialize_1.autoserializeAs('shippingDiscountTaxCompensationAmount')
], OrderEntity.prototype, "shippingDiscountTaxCompensationAmount", void 0);
__decorate([
    cerialize_1.autoserializeAs('totalShippingAmount')
], OrderEntity.prototype, "totalShippingAmount", void 0);
__decorate([
    class_validator_1.ValidateNested(),
    cerialize_1.autoserializeAs(OrderItem, 'items')
], OrderEntity.prototype, "items", void 0);
OrderEntity = __decorate([
    cerialize_1.inheritSerialization(base_1.DynamoBaseEntity)
], OrderEntity);
exports.OrderEntity = OrderEntity;
//# sourceMappingURL=orders.js.map