"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var InCartProduct_1, MultipleLangInCartProduct_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.PayloadReserveStock = exports.ReserveStock = exports.PayloadUpdateStockIncart = exports.Products = exports.PayloadStock = exports.Payloads = exports.MultipleLangInCartProduct = exports.InCartProduct = exports.ToPage = exports.PaymentMethods = exports.Attributes = exports.LangOptions = exports.LocalizedOptions = exports.BaseOptions = exports.SubOptions = exports.Badge = exports.Brand = exports.LangTaxonomy = exports.LocalizedTaxonomy = exports.StockReserve = exports.Media = exports.Stock = exports.ProductRef = exports.Channel = exports.ChannelWarehouses = exports.Warehouse = exports.Inventory = exports.WareHouse = exports.LangsSuggest = exports.Suggest = exports.PriceFormat = exports.MinMaxValue = void 0;
const cerialize_1 = require("cerialize");
const base_1 = require("./base");
class MinMaxValue {
    static zero() {
        const v = new MinMaxValue();
        v.min = 0;
        v.max = 0;
        return v;
    }
}
__decorate([
    cerialize_1.autoserializeAs('min')
], MinMaxValue.prototype, "min", void 0);
__decorate([
    cerialize_1.autoserializeAs('max')
], MinMaxValue.prototype, "max", void 0);
exports.MinMaxValue = MinMaxValue;
class PriceFormat {
    constructor() {
        this.special = null;
    }
    static noNull(value) {
        const pf = new PriceFormat();
        if (!value) {
            pf.original = MinMaxValue.zero();
            pf.special = null;
            return pf;
        }
        pf.original = new MinMaxValue();
        pf.original.min = (value.original && value.original?.min) ?? value.original?.min ?? 0;
        pf.original.max = (value.original && value.original?.max) ?? value.original?.max ?? 0;
        pf.special = new MinMaxValue();
        pf.special.min = (value.special && value.special?.min) ?? value.special?.min ?? 0;
        pf.special.max = (value.special && value.special?.max) ?? value.special?.max ?? 0;
        return pf;
    }
}
__decorate([
    cerialize_1.autoserializeAs(MinMaxValue, 'original')
], PriceFormat.prototype, "original", void 0);
__decorate([
    cerialize_1.autoserializeAs(MinMaxValue, 'special')
], PriceFormat.prototype, "special", void 0);
exports.PriceFormat = PriceFormat;
class Suggest {
}
__decorate([
    cerialize_1.autoserializeAs('input')
], Suggest.prototype, "input", void 0);
__decorate([
    cerialize_1.autoserializeAs('contexts')
], Suggest.prototype, "contexts", void 0);
exports.Suggest = Suggest;
class LangsSuggest {
}
__decorate([
    cerialize_1.autoserializeAs('en')
], LangsSuggest.prototype, "en", void 0);
__decorate([
    cerialize_1.autoserializeAs('th')
], LangsSuggest.prototype, "th", void 0);
exports.LangsSuggest = LangsSuggest;
class WareHouse {
}
__decorate([
    cerialize_1.autoserializeAs('id')
], WareHouse.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('name')
], WareHouse.prototype, "name", void 0);
__decorate([
    cerialize_1.autoserializeAs('active')
], WareHouse.prototype, "active", void 0);
__decorate([
    cerialize_1.autoserializeAs('created_at')
], WareHouse.prototype, "created_at", void 0);
__decorate([
    cerialize_1.autoserializeAs('updated_at')
], WareHouse.prototype, "updated_at", void 0);
exports.WareHouse = WareHouse;
class Inventory {
}
__decorate([
    cerialize_1.autoserializeAs('qty')
], Inventory.prototype, "qty", void 0);
__decorate([
    cerialize_1.autoserializeAs('stockType')
], Inventory.prototype, "stockType", void 0);
exports.Inventory = Inventory;
class Warehouse {
    constructor() {
        this.active = false;
        this.updated_at = null;
    }
}
__decorate([
    cerialize_1.autoserializeAs('id')
], Warehouse.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('name')
], Warehouse.prototype, "name", void 0);
__decorate([
    cerialize_1.autoserializeAs('active')
], Warehouse.prototype, "active", void 0);
__decorate([
    cerialize_1.autoserializeAs('created_at')
], Warehouse.prototype, "created_at", void 0);
__decorate([
    cerialize_1.autoserializeAs(Warehouse, 'updated_at')
], Warehouse.prototype, "updated_at", void 0);
exports.Warehouse = Warehouse;
class ChannelWarehouses {
}
__decorate([
    cerialize_1.autoserializeAs('id')
], ChannelWarehouses.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('channelId')
], ChannelWarehouses.prototype, "channelId", void 0);
__decorate([
    cerialize_1.autoserializeAs('warehouseId')
], ChannelWarehouses.prototype, "warehouseId", void 0);
__decorate([
    cerialize_1.autoserializeAs('warehouse_id')
], ChannelWarehouses.prototype, "warehouse_id", void 0);
__decorate([
    cerialize_1.autoserializeAs(Warehouse, 'warehouse')
], ChannelWarehouses.prototype, "warehouse", void 0);
exports.ChannelWarehouses = ChannelWarehouses;
class Channel {
}
__decorate([
    cerialize_1.autoserializeAs('id')
], Channel.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('type')
], Channel.prototype, "type", void 0);
__decorate([
    cerialize_1.autoserializeAs('name')
], Channel.prototype, "name", void 0);
__decorate([
    cerialize_1.autoserializeAs('updatedAt')
], Channel.prototype, "updatedAt", void 0);
__decorate([
    cerialize_1.autoserializeAs('createdAt')
], Channel.prototype, "createdAt", void 0);
__decorate([
    cerialize_1.autoserializeAs(ChannelWarehouses, 'channel_warehouses')
], Channel.prototype, "channel_warehouses", void 0);
exports.Channel = Channel;
class ProductRef {
}
__decorate([
    cerialize_1.autoserializeAs('id')
], ProductRef.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('productId')
], ProductRef.prototype, "productId", void 0);
__decorate([
    cerialize_1.autoserializeAs('channelId')
], ProductRef.prototype, "channelId", void 0);
__decorate([
    cerialize_1.autoserializeAs('name')
], ProductRef.prototype, "name", void 0);
__decorate([
    cerialize_1.autoserializeAs('itemId')
], ProductRef.prototype, "itemId", void 0);
__decorate([
    cerialize_1.autoserializeAs('variantId')
], ProductRef.prototype, "variantId", void 0);
__decorate([
    cerialize_1.autoserializeAs('price')
], ProductRef.prototype, "price", void 0);
__decorate([
    cerialize_1.autoserializeAs('specialPrice')
], ProductRef.prototype, "specialPrice", void 0);
__decorate([
    cerialize_1.autoserializeAs('refType')
], ProductRef.prototype, "refType", void 0);
__decorate([
    cerialize_1.autoserializeAs('channel_id')
], ProductRef.prototype, "channel_id", void 0);
__decorate([
    cerialize_1.autoserializeAs(Channel, 'channel')
], ProductRef.prototype, "channel", void 0);
exports.ProductRef = ProductRef;
class Stock {
}
__decorate([
    cerialize_1.autoserializeAs('sku')
], Stock.prototype, "sku", void 0);
__decorate([
    cerialize_1.autoserializeAs('indexId')
], Stock.prototype, "indexId", void 0);
__decorate([
    cerialize_1.autoserializeAs('qty')
], Stock.prototype, "qty", void 0);
__decorate([
    cerialize_1.autoserializeAs('productId')
], Stock.prototype, "productId", void 0);
__decorate([
    cerialize_1.autoserializeAs('stockType')
], Stock.prototype, "stockType", void 0);
__decorate([
    cerialize_1.autoserializeAs('warehouseId')
], Stock.prototype, "warehouseId", void 0);
__decorate([
    cerialize_1.autoserializeAs('refillThresholdValue')
], Stock.prototype, "refillThresholdValue", void 0);
__decorate([
    cerialize_1.autoserializeAs('updatedAt')
], Stock.prototype, "updatedAt", void 0);
exports.Stock = Stock;
class Media {
}
__decorate([
    cerialize_1.autoserializeAs('id')
], Media.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('path')
], Media.prototype, "path", void 0);
__decorate([
    cerialize_1.autoserializeAs('type')
], Media.prototype, "type", void 0);
__decorate([
    cerialize_1.autoserializeAs('ref')
], Media.prototype, "ref", void 0);
__decorate([
    cerialize_1.autoserializeAs('position')
], Media.prototype, "position", void 0);
exports.Media = Media;
class StockReserve {
}
__decorate([
    cerialize_1.autoserializeAs('orderId')
], StockReserve.prototype, "orderId", void 0);
__decorate([
    cerialize_1.autoserializeAs('qty')
], StockReserve.prototype, "qty", void 0);
exports.StockReserve = StockReserve;
class BaseTaxonomy {
}
__decorate([
    cerialize_1.autoserializeAs('id')
], BaseTaxonomy.prototype, "id", void 0);
let LocalizedTaxonomy = class LocalizedTaxonomy extends BaseTaxonomy {
};
__decorate([
    cerialize_1.autoserializeAs('label')
], LocalizedTaxonomy.prototype, "label", void 0);
LocalizedTaxonomy = __decorate([
    cerialize_1.inheritSerialization(BaseTaxonomy)
], LocalizedTaxonomy);
exports.LocalizedTaxonomy = LocalizedTaxonomy;
let LangTaxonomy = class LangTaxonomy extends BaseTaxonomy {
};
__decorate([
    cerialize_1.autoserializeAs(base_1.LangPair, 'label')
], LangTaxonomy.prototype, "label", void 0);
LangTaxonomy = __decorate([
    cerialize_1.inheritSerialization(BaseTaxonomy)
], LangTaxonomy);
exports.LangTaxonomy = LangTaxonomy;
class Brand {
    constructor() {
        this.label = null;
    }
}
__decorate([
    cerialize_1.autoserializeAs('id')
], Brand.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('label')
], Brand.prototype, "label", void 0);
__decorate([
    cerialize_1.autoserializeAs('actualValue')
], Brand.prototype, "actualValue", void 0);
exports.Brand = Brand;
class Badge {
}
__decorate([
    cerialize_1.autoserializeAs('id')
], Badge.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('label')
], Badge.prototype, "label", void 0);
__decorate([
    cerialize_1.autoserializeAs('actualValue')
], Badge.prototype, "actualValue", void 0);
exports.Badge = Badge;
class SubOptions {
}
__decorate([
    cerialize_1.autoserializeAs('id')
], SubOptions.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('label')
], SubOptions.prototype, "label", void 0);
__decorate([
    cerialize_1.autoserializeAs('actualValue')
], SubOptions.prototype, "actualValue", void 0);
exports.SubOptions = SubOptions;
class BaseOptions {
}
__decorate([
    cerialize_1.autoserializeAs('attributeId')
], BaseOptions.prototype, "attributeId", void 0);
__decorate([
    cerialize_1.autoserializeAs('type')
], BaseOptions.prototype, "type", void 0);
__decorate([
    cerialize_1.autoserializeAs('code')
], BaseOptions.prototype, "code", void 0);
__decorate([
    cerialize_1.autoserializeAs(base_1.LangPair, 'label')
], BaseOptions.prototype, "label", void 0);
__decorate([
    cerialize_1.autoserializeAs(SubOptions, 'options')
], BaseOptions.prototype, "options", void 0);
exports.BaseOptions = BaseOptions;
let LocalizedOptions = class LocalizedOptions {
};
__decorate([
    cerialize_1.autoserializeAs('label')
], LocalizedOptions.prototype, "label", void 0);
LocalizedOptions = __decorate([
    cerialize_1.inheritSerialization(BaseOptions)
], LocalizedOptions);
exports.LocalizedOptions = LocalizedOptions;
let LangOptions = class LangOptions extends BaseOptions {
};
__decorate([
    cerialize_1.autoserializeAs(base_1.LangPair, 'label')
], LangOptions.prototype, "label", void 0);
LangOptions = __decorate([
    cerialize_1.inheritSerialization(BaseOptions)
], LangOptions);
exports.LangOptions = LangOptions;
class Attributes {
}
__decorate([
    cerialize_1.autoserializeAs(BaseOptions, 'options')
], Attributes.prototype, "options", void 0);
exports.Attributes = Attributes;
class PaymentMethods {
}
__decorate([
    cerialize_1.autoserializeAs('id')
], PaymentMethods.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('isBrandActive')
], PaymentMethods.prototype, "isBrandActive", void 0);
exports.PaymentMethods = PaymentMethods;
class ToPage {
}
__decorate([
    cerialize_1.autoserializeAs('pageId')
], ToPage.prototype, "pageId", void 0);
__decorate([
    cerialize_1.autoserializeAs('labelTh')
], ToPage.prototype, "labelTh", void 0);
__decorate([
    cerialize_1.autoserializeAs('labelEn')
], ToPage.prototype, "labelEn", void 0);
__decorate([
    cerialize_1.autoserializeAs('sortOrder')
], ToPage.prototype, "sortOrder", void 0);
exports.ToPage = ToPage;
/* Raw product from inCart */
class BaseInCartProduct {
    // Not-relevant do not map.
    // @autoserializeAs('chainStore')
    // chainStore: object
    // @autoserializeAs(PaymentMethods, 'paymentMethods')
    // paymentMethods!: PaymentMethods[] | null
    // Not-relevant do not map.
    // @autoserializeAs('specialCondition')
    // specialCondition: object
    // Not-relevant do not map.
    // @autoserializeAs(ToPage, 'toPage')
    // toPage: ToPage[] | null
    constructor(from = null) {
        if (!from) {
            return;
        }
        this.id = from.id;
        this.sku = from.sku;
        this.storeId = from.storeId;
        this.type = from.type;
        this.width = from.width;
        this.weight = from.weight;
        this.height = from.height;
        this.length = from.length;
        this.media = from.media;
        this.visibility = from.visibility;
        this.status = from.status;
        this.createdAt = from.createdAt;
        this.updatedAt = from.updatedAt;
        this.price = PriceFormat.noNull(from.price);
        this.stock = from.stock;
        this.inventory = from.inventory;
        this.media = from.media;
        this.brand = from.brand;
        this.badge = from.badge;
        this.properties = from.properties;
        this.attributes = from.attributes;
        // this.paymentMethods = from.paymentMethods
    }
}
__decorate([
    cerialize_1.autoserializeAs('id')
], BaseInCartProduct.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('sku')
], BaseInCartProduct.prototype, "sku", void 0);
__decorate([
    cerialize_1.autoserializeAs('storeId')
], BaseInCartProduct.prototype, "storeId", void 0);
__decorate([
    cerialize_1.autoserializeAs('type')
], BaseInCartProduct.prototype, "type", void 0);
__decorate([
    cerialize_1.autoserializeAs('width')
], BaseInCartProduct.prototype, "width", void 0);
__decorate([
    cerialize_1.autoserializeAs('height')
], BaseInCartProduct.prototype, "height", void 0);
__decorate([
    cerialize_1.autoserializeAs('length')
], BaseInCartProduct.prototype, "length", void 0);
__decorate([
    cerialize_1.autoserializeAs('weight')
], BaseInCartProduct.prototype, "weight", void 0);
__decorate([
    cerialize_1.autoserializeAs('visibility')
], BaseInCartProduct.prototype, "visibility", void 0);
__decorate([
    cerialize_1.autoserializeAs('status')
], BaseInCartProduct.prototype, "status", void 0);
__decorate([
    cerialize_1.autoserializeAs('createdAt')
], BaseInCartProduct.prototype, "createdAt", void 0);
__decorate([
    cerialize_1.autoserializeAs('updatedAt')
], BaseInCartProduct.prototype, "updatedAt", void 0);
__decorate([
    cerialize_1.autoserializeAs(PriceFormat, 'price')
], BaseInCartProduct.prototype, "price", void 0);
__decorate([
    cerialize_1.autoserializeAs(Stock, 'stock')
], BaseInCartProduct.prototype, "stock", void 0);
__decorate([
    cerialize_1.autoserializeAs(Inventory, 'inventory')
], BaseInCartProduct.prototype, "inventory", void 0);
__decorate([
    cerialize_1.autoserializeAs(Media, 'media')
], BaseInCartProduct.prototype, "media", void 0);
__decorate([
    cerialize_1.autoserializeAs('refillThresholdValue')
], BaseInCartProduct.prototype, "refillThresholdValue", void 0);
__decorate([
    cerialize_1.autoserializeAs(Brand, 'brand')
], BaseInCartProduct.prototype, "brand", void 0);
__decorate([
    cerialize_1.autoserializeAs(Badge, 'badge')
], BaseInCartProduct.prototype, "badge", void 0);
__decorate([
    cerialize_1.autoserializeAs('properties')
], BaseInCartProduct.prototype, "properties", void 0);
__decorate([
    cerialize_1.autoserializeAs(Attributes, 'attributes')
], BaseInCartProduct.prototype, "attributes", void 0);
let InCartProduct = InCartProduct_1 = class InCartProduct extends BaseInCartProduct {
    constructor(from = null) {
        super(from);
        if (!from) {
            return;
        }
        this.name = from.name;
        this.description = from.description;
        this.categories = from.categories;
        this.tags = from.tags;
        this.children = from.children;
    }
};
__decorate([
    cerialize_1.autoserializeAs('name')
], InCartProduct.prototype, "name", void 0);
__decorate([
    cerialize_1.autoserializeAs('description')
], InCartProduct.prototype, "description", void 0);
__decorate([
    cerialize_1.autoserializeAs(LocalizedTaxonomy, 'categories')
], InCartProduct.prototype, "categories", void 0);
__decorate([
    cerialize_1.autoserializeAs(LangTaxonomy, 'tags')
], InCartProduct.prototype, "tags", void 0);
__decorate([
    cerialize_1.autoserializeAs(InCartProduct_1, 'children')
], InCartProduct.prototype, "children", void 0);
InCartProduct = InCartProduct_1 = __decorate([
    cerialize_1.inheritSerialization(BaseInCartProduct)
], InCartProduct);
exports.InCartProduct = InCartProduct;
let MultipleLangInCartProduct = MultipleLangInCartProduct_1 = class MultipleLangInCartProduct extends BaseInCartProduct {
    constructor(from = null) {
        super(from);
        this.children = [];
        this.backInStockTimeStamp = 0;
        if (!from) {
            return;
        }
        this.name = from.name;
        this.description = from.description;
        this.categories = from.categories;
        this.tags = from.tags;
        this.children = from.children;
    }
};
__decorate([
    cerialize_1.autoserializeAs('byStoreId')
], MultipleLangInCartProduct.prototype, "byStoreId", void 0);
__decorate([
    cerialize_1.autoserializeAs(base_1.LangPair, 'name')
], MultipleLangInCartProduct.prototype, "name", void 0);
__decorate([
    cerialize_1.autoserializeAs(base_1.LangPair, 'title')
], MultipleLangInCartProduct.prototype, "title", void 0);
__decorate([
    cerialize_1.autoserializeAs(base_1.LangPair, 'description')
], MultipleLangInCartProduct.prototype, "description", void 0);
__decorate([
    cerialize_1.autoserializeAs(LangTaxonomy, 'categories')
], MultipleLangInCartProduct.prototype, "categories", void 0);
__decorate([
    cerialize_1.autoserializeAs(LangTaxonomy, 'tags')
], MultipleLangInCartProduct.prototype, "tags", void 0);
__decorate([
    cerialize_1.autoserializeAs('codeColor')
], MultipleLangInCartProduct.prototype, "codeColor", void 0);
__decorate([
    cerialize_1.autoserializeAs('colorSwatch')
], MultipleLangInCartProduct.prototype, "colorSwatch", void 0);
__decorate([
    cerialize_1.autoserializeAs(MultipleLangInCartProduct_1, 'children')
], MultipleLangInCartProduct.prototype, "children", void 0);
__decorate([
    cerialize_1.autoserializeAs(StockReserve, 'stockReserve')
], MultipleLangInCartProduct.prototype, "stockReserve", void 0);
__decorate([
    cerialize_1.autoserializeAs('vizCoin')
], MultipleLangInCartProduct.prototype, "vizCoin", void 0);
__decorate([
    cerialize_1.autoserializeAs('rawQty')
], MultipleLangInCartProduct.prototype, "rawQty", void 0);
__decorate([
    cerialize_1.autoserializeAs('refillStock')
], MultipleLangInCartProduct.prototype, "refillStock", void 0);
__decorate([
    cerialize_1.autoserializeAs('backInStockTimeStamp')
], MultipleLangInCartProduct.prototype, "backInStockTimeStamp", void 0);
MultipleLangInCartProduct = MultipleLangInCartProduct_1 = __decorate([
    cerialize_1.inheritSerialization(BaseInCartProduct)
], MultipleLangInCartProduct);
exports.MultipleLangInCartProduct = MultipleLangInCartProduct;
class Payloads {
}
__decorate([
    cerialize_1.autoserializeAs(Stock, 'stocks')
], Payloads.prototype, "stocks", void 0);
__decorate([
    cerialize_1.autoserializeAs('refillThresholdValue')
], Payloads.prototype, "refillThresholdValue", void 0);
__decorate([
    cerialize_1.autoserializeAs('updatedAt')
], Payloads.prototype, "updatedAt", void 0);
exports.Payloads = Payloads;
class PayloadStock {
}
__decorate([
    cerialize_1.autoserializeAs(Payloads, 'payloads')
], PayloadStock.prototype, "payloads", void 0);
__decorate([
    cerialize_1.autoserializeAs('storeId')
], PayloadStock.prototype, "storeId", void 0);
exports.PayloadStock = PayloadStock;
class Products {
}
__decorate([
    cerialize_1.autoserializeAs('id')
], Products.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('sku')
], Products.prototype, "sku", void 0);
__decorate([
    cerialize_1.autoserializeAs('stockType')
], Products.prototype, "stockType", void 0);
__decorate([
    cerialize_1.autoserializeAs('qty')
], Products.prototype, "qty", void 0);
__decorate([
    cerialize_1.autoserializeAs('type')
], Products.prototype, "type", void 0);
exports.Products = Products;
class PayloadUpdateStockIncart {
}
__decorate([
    cerialize_1.autoserializeAs(Products, 'products')
], PayloadUpdateStockIncart.prototype, "products", void 0);
__decorate([
    cerialize_1.autoserializeAs('storeId')
], PayloadUpdateStockIncart.prototype, "storeId", void 0);
exports.PayloadUpdateStockIncart = PayloadUpdateStockIncart;
class ReserveStock {
}
__decorate([
    cerialize_1.autoserializeAs('sku')
], ReserveStock.prototype, "sku", void 0);
__decorate([
    cerialize_1.autoserializeAs('storeId')
], ReserveStock.prototype, "storeId", void 0);
__decorate([
    cerialize_1.autoserializeAs('orderId')
], ReserveStock.prototype, "orderId", void 0);
__decorate([
    cerialize_1.autoserializeAs('qty')
], ReserveStock.prototype, "qty", void 0);
__decorate([
    cerialize_1.autoserializeAs('indexId')
], ReserveStock.prototype, "indexId", void 0);
__decorate([
    cerialize_1.autoserializeAs('returnStock')
], ReserveStock.prototype, "returnStock", void 0);
exports.ReserveStock = ReserveStock;
class PayloadReserveStock {
}
__decorate([
    cerialize_1.autoserializeAs(ReserveStock, 'payloads')
], PayloadReserveStock.prototype, "payloads", void 0);
exports.PayloadReserveStock = PayloadReserveStock;
//# sourceMappingURL=products.js.map