"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InCartStoreNameCandidateValidation = exports.InCartStore = exports.InCartLocation = exports.InCartStorePackage = void 0;
const cerialize_1 = require("cerialize");
const cerialize_2 = require("../../utils/cerialize");
const base_1 = require("./base");
class InCartPackageFeature {
    constructor() {
        this.chats = false;
        this.clickAndCollect = false;
        this.creditTerms = false;
        this.customerTier = false;
        this.domain = false;
        this.orderManager = false;
        this.quotation = false;
        this.report = false;
        this.stockManage = false;
        this.syncMarketPlace = false;
    }
}
__decorate([
    cerialize_1.autoserializeAs('chats')
], InCartPackageFeature.prototype, "chats", void 0);
__decorate([
    cerialize_1.autoserializeAs('clickAndCollect')
], InCartPackageFeature.prototype, "clickAndCollect", void 0);
__decorate([
    cerialize_1.autoserializeAs('creditTerms')
], InCartPackageFeature.prototype, "creditTerms", void 0);
__decorate([
    cerialize_1.autoserializeAs('customerTier')
], InCartPackageFeature.prototype, "customerTier", void 0);
__decorate([
    cerialize_1.autoserializeAs('domain')
], InCartPackageFeature.prototype, "domain", void 0);
__decorate([
    cerialize_1.autoserializeAs('orderManager')
], InCartPackageFeature.prototype, "orderManager", void 0);
__decorate([
    cerialize_1.autoserializeAs('quotation')
], InCartPackageFeature.prototype, "quotation", void 0);
__decorate([
    cerialize_1.autoserializeAs('report')
], InCartPackageFeature.prototype, "report", void 0);
__decorate([
    cerialize_1.autoserializeAs('stockManage')
], InCartPackageFeature.prototype, "stockManage", void 0);
__decorate([
    cerialize_1.autoserializeAs('syncMarketPlace')
], InCartPackageFeature.prototype, "syncMarketPlace", void 0);
__decorate([
    cerialize_1.autoserializeAs('ordersLimit')
], InCartPackageFeature.prototype, "ordersLimit", void 0);
__decorate([
    cerialize_1.autoserializeAs('productsLimit')
], InCartPackageFeature.prototype, "productsLimit", void 0);
__decorate([
    cerialize_1.autoserializeAs('staffsLimit')
], InCartPackageFeature.prototype, "staffsLimit", void 0);
__decorate([
    cerialize_1.autoserializeAs('tier')
], InCartPackageFeature.prototype, "tier", void 0);
__decorate([
    cerialize_1.autoserializeAs('type')
], InCartPackageFeature.prototype, "type", void 0);
__decorate([
    cerialize_1.autoserializeAs('id')
], InCartPackageFeature.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('name')
], InCartPackageFeature.prototype, "name", void 0);
class InCartPackage {
}
__decorate([
    cerialize_1.autoserializeAs('active')
], InCartPackage.prototype, "active", void 0);
__decorate([
    cerialize_1.autoserializeAs('createdAt')
], InCartPackage.prototype, "createdAt", void 0);
__decorate([
    cerialize_1.autoserializeAs('duration')
], InCartPackage.prototype, "duration", void 0);
__decorate([
    cerialize_1.autoserializeAs('id')
], InCartPackage.prototype, "id", void 0);
__decorate([
    cerialize_1.autoserializeAs('name')
], InCartPackage.prototype, "name", void 0);
__decorate([
    cerialize_1.autoserializeAs('paymentType')
], InCartPackage.prototype, "paymentType", void 0);
__decorate([
    cerialize_1.autoserializeAs('planId')
], InCartPackage.prototype, "planId", void 0);
__decorate([
    cerialize_1.autoserializeAs('price')
], InCartPackage.prototype, "price", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.ISODateSerializer, 'updatedAt')
], InCartPackage.prototype, "updatedAt", void 0);
__decorate([
    cerialize_1.autoserializeAs(InCartPackageFeature, 'features')
], InCartPackage.prototype, "features", void 0);
class InCartStorePackage {
}
__decorate([
    cerialize_1.autoserializeAs('storeId')
], InCartStorePackage.prototype, "storeId", void 0);
__decorate([
    cerialize_1.autoserializeAs('cycleDate')
], InCartStorePackage.prototype, "cycleDate", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.ISODateSerializer, 'dueDate')
], InCartStorePackage.prototype, "dueDate", void 0);
__decorate([
    cerialize_1.autoserializeAs(cerialize_2.ISODateSerializer, 'updatedAt')
], InCartStorePackage.prototype, "updatedAt", void 0);
__decorate([
    cerialize_1.autoserializeAs('packageId')
], InCartStorePackage.prototype, "packageId", void 0);
__decorate([
    cerialize_1.autoserializeAs(InCartPackage, 'package')
], InCartStorePackage.prototype, "package", void 0);
exports.InCartStorePackage = InCartStorePackage;
class InCartLocation {
    constructor(storeId) {
        this.storeId = storeId;
    }
}
__decorate([
    cerialize_1.autoserializeAs('baseURL')
], InCartLocation.prototype, "baseURL", void 0);
__decorate([
    cerialize_1.autoserializeAs('host')
], InCartLocation.prototype, "host", void 0);
__decorate([
    cerialize_1.autoserializeAs('storeBaseURL')
], InCartLocation.prototype, "storeBaseURL", void 0);
__decorate([
    cerialize_1.autoserializeAs('storeHost')
], InCartLocation.prototype, "storeHost", void 0);
exports.InCartLocation = InCartLocation;
class InCartStoreCurrency {
    constructor() {
        this.storeCurrency = new base_1.DefaultKeyValue('THB');
    }
}
__decorate([
    cerialize_1.autoserializeAs(base_1.DefaultKeyValue, 'storeCurrency')
], InCartStoreCurrency.prototype, "storeCurrency", void 0);
class InCartStore {
    constructor(storeId) {
        this.storeName = base_1.LangPair.empty();
        this.storeDescription = base_1.LangPair.empty();
        this.timezone = new base_1.DefaultKeyValue(7);
        this.storeId = storeId;
    }
}
__decorate([
    cerialize_1.autoserializeAs('storeId')
], InCartStore.prototype, "storeId", void 0);
__decorate([
    cerialize_1.autoserializeAs('taxId')
], InCartStore.prototype, "taxId", void 0);
__decorate([
    cerialize_1.autoserializeAs('storeLogo')
], InCartStore.prototype, "storeLogo", void 0);
__decorate([
    cerialize_1.autoserializeAs('storeLogoMobile')
], InCartStore.prototype, "storeLogoMobile", void 0);
__decorate([
    cerialize_1.autoserializeAs('favicon')
], InCartStore.prototype, "favicon", void 0);
__decorate([
    cerialize_1.autoserializeAs(base_1.LangPair, 'storeName')
], InCartStore.prototype, "storeName", void 0);
__decorate([
    cerialize_1.autoserializeAs('mobile')
], InCartStore.prototype, "mobile", void 0);
__decorate([
    cerialize_1.autoserializeAs(base_1.LangPair, 'storeDescription')
], InCartStore.prototype, "storeDescription", void 0);
__decorate([
    cerialize_1.autoserializeAs(InCartStoreCurrency, 'currency')
], InCartStore.prototype, "currency", void 0);
__decorate([
    cerialize_1.autoserializeAs(base_1.DefaultKeyValue, 'timezone')
], InCartStore.prototype, "timezone", void 0);
exports.InCartStore = InCartStore;
class InCartStoreNameCandidateValidation {
}
__decorate([
    cerialize_1.autoserializeAs('exist')
], InCartStoreNameCandidateValidation.prototype, "exist", void 0);
__decorate([
    cerialize_1.autoserializeAs('storeId')
], InCartStoreNameCandidateValidation.prototype, "storeId", void 0);
exports.InCartStoreNameCandidateValidation = InCartStoreNameCandidateValidation;
//# sourceMappingURL=store.js.map