import Fraction from 'fraction.js';
import { DynamoBaseEntity } from './base';
export declare class OrderItem {
    itemId: String;
    orderId: String;
    sku: String;
    originalPrice: Fraction;
    price: Fraction;
    priceInclTax: Fraction;
    rowTotal: Fraction;
    rowTotalInclTax: Fraction;
    rowTotalWithDiscount: Fraction;
    taxAmount: Fraction;
    taxBeforeDiscount: Fraction;
    taxPercent: Fraction;
    taxInvoiced: Fraction;
    taxRefunded: Fraction;
    discountAmount: Fraction;
    discountPercent: Fraction;
    discountTaxCompensationAmount: Fraction;
    name?: String;
    qty: number;
    qtyCanceled: number;
    qtyInvoiced: number;
    qtyOrdered: number;
    qtyRefunded: number;
    qtyShipped: number;
    refItemId?: number;
    rawData?: String;
    weight?: number;
    createdAt: Date;
    updatedAt: Date;
    paymentGatewayMdr: Fraction;
}
export declare class OrderEntity extends DynamoBaseEntity {
    orderId: string;
    storeId: string;
    cartId?: string;
    mapOrderId?: number;
    orderToken: string;
    appliedRuleIds: string[];
    couponCode?: string;
    appliedRules: {}[];
    couponRuleName?: string;
    status: 'new' | 'pending' | 'paid' | 'canceled' | 'waiting_to_ship';
    customerId?: string;
    name: string;
    email: string;
    isArchived: boolean;
    grandTotal: Fraction;
    subtotal: Fraction;
    subtotalInclTax: Fraction;
    subtotalInvoiced: Fraction;
    subtotalCanceled: Fraction;
    subtotalRefunded: Fraction;
    discountAmount: Fraction;
    discountInvoiced: Fraction;
    discountRefunded: Fraction;
    taxAmount: Fraction;
    taxCanceled: Fraction;
    taxInvoiced: Fraction;
    taxRefunded: Fraction;
    discountTaxCompensationAmount: Fraction;
    customShipping: Fraction;
    specialDiscountAmount: Fraction;
    totalProduct: number;
    totalQty: number;
    totalCanceled: number;
    totalInvoiced: number;
    totalRefunded: number;
    paymentMethodId: number;
    shippingAmount: Fraction;
    shippingDiscountAmount: Fraction;
    shippingInclTax: Fraction;
    shippingTaxAmount: Fraction;
    shippingMethodId?: number;
    shippingMethodName?: string;
    shippingMethodDetail: string;
    globalCurrencyCode?: string;
    orderCurrencyCode?: string;
    globalToOrderRate: Fraction;
    weight?: number;
    expiredAt?: string;
    chainStoreId: string;
    chainStoreDetail?: string;
    channelId?: number;
    orderRef?: string;
    rawData?: string;
    remark?: string;
    isGrandTotalOverrode?: string;
    meta?: string;
    lastPrinte?: Date;
    shippingDiscountTaxCompensationAmount: number;
    totalShippingAmount: number;
    items?: OrderItem[];
}
