var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { autoserializeAs, inheritSerialization } from 'cerialize';
import { IsNotEmpty, ValidateNested, IsEmail } from 'class-validator';
import Fraction from 'fraction.js';
import { DynamoBaseEntity } from './base';
import { DateSerializer, FractionSerializer } from "../../utils/cerialize";
export class OrderItem {
    constructor() {
        this.originalPrice = new Fraction(0);
        this.price = new Fraction(0);
        this.priceInclTax = new Fraction(0);
        this.rowTotal = new Fraction(0);
        this.rowTotalInclTax = new Fraction(0);
        this.rowTotalWithDiscount = new Fraction(0);
        this.taxAmount = new Fraction(0);
        this.taxBeforeDiscount = new Fraction(0);
        this.taxPercent = new Fraction(0);
        this.taxInvoiced = new Fraction(0);
        this.taxRefunded = new Fraction(0);
        this.discountAmount = new Fraction(0);
        this.discountPercent = new Fraction(0);
        this.discountTaxCompensationAmount = new Fraction(0);
        this.qty = 0;
        this.qtyCanceled = 0;
        this.qtyInvoiced = 0;
        this.qtyOrdered = 0;
        this.qtyRefunded = 0;
        this.qtyShipped = 0;
        this.paymentGatewayMdr = new Fraction(0);
    }
}
__decorate([
    autoserializeAs('itemId')
], OrderItem.prototype, "itemId", void 0);
__decorate([
    autoserializeAs('orderId')
], OrderItem.prototype, "orderId", void 0);
__decorate([
    IsNotEmpty(),
    autoserializeAs('sku')
], OrderItem.prototype, "sku", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'originalPrice')
], OrderItem.prototype, "originalPrice", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'price')
], OrderItem.prototype, "price", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'priceInclTax')
], OrderItem.prototype, "priceInclTax", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'rowTotal')
], OrderItem.prototype, "rowTotal", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'rowTotalInclTax')
], OrderItem.prototype, "rowTotalInclTax", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'rowTotalWithDiscount')
], OrderItem.prototype, "rowTotalWithDiscount", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'taxAmount')
], OrderItem.prototype, "taxAmount", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'taxBeforeDiscount')
], OrderItem.prototype, "taxBeforeDiscount", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'taxPercent')
], OrderItem.prototype, "taxPercent", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'taxInvoiced')
], OrderItem.prototype, "taxInvoiced", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'taxRefunded')
], OrderItem.prototype, "taxRefunded", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'discountAmount')
], OrderItem.prototype, "discountAmount", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'discountPercent')
], OrderItem.prototype, "discountPercent", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'discountTaxCompensationAmount')
], OrderItem.prototype, "discountTaxCompensationAmount", void 0);
__decorate([
    autoserializeAs('name')
], OrderItem.prototype, "name", void 0);
__decorate([
    autoserializeAs('qty')
], OrderItem.prototype, "qty", void 0);
__decorate([
    autoserializeAs('qtyCanceled')
], OrderItem.prototype, "qtyCanceled", void 0);
__decorate([
    autoserializeAs('qtyInvoiced')
], OrderItem.prototype, "qtyInvoiced", void 0);
__decorate([
    autoserializeAs('qtyOrdered')
], OrderItem.prototype, "qtyOrdered", void 0);
__decorate([
    autoserializeAs('qtyRefunded')
], OrderItem.prototype, "qtyRefunded", void 0);
__decorate([
    autoserializeAs('qtyShipped')
], OrderItem.prototype, "qtyShipped", void 0);
__decorate([
    autoserializeAs('refItemId')
], OrderItem.prototype, "refItemId", void 0);
__decorate([
    autoserializeAs('rawData')
], OrderItem.prototype, "rawData", void 0);
__decorate([
    autoserializeAs('weight')
], OrderItem.prototype, "weight", void 0);
__decorate([
    autoserializeAs(DateSerializer, 'createdAt')
], OrderItem.prototype, "createdAt", void 0);
__decorate([
    autoserializeAs(DateSerializer, 'updatedAt')
], OrderItem.prototype, "updatedAt", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'paymentGatewayMdr')
], OrderItem.prototype, "paymentGatewayMdr", void 0);
let OrderEntity = class OrderEntity extends DynamoBaseEntity {
    constructor() {
        super(...arguments);
        this.orderToken = '';
        this.appliedRuleIds = [];
        this.appliedRules = [];
        this.status = 'new';
        this.isArchived = false;
        this.grandTotal = new Fraction(0);
        this.subtotal = new Fraction(0);
        this.subtotalInclTax = new Fraction(0);
        this.subtotalInvoiced = new Fraction(0);
        this.subtotalCanceled = new Fraction(0);
        this.subtotalRefunded = new Fraction(0);
        this.discountAmount = new Fraction(0);
        this.discountInvoiced = new Fraction(0);
        this.discountRefunded = new Fraction(0);
        this.taxAmount = new Fraction(0);
        this.taxCanceled = new Fraction(0);
        this.taxInvoiced = new Fraction(0);
        this.taxRefunded = new Fraction(0);
        this.discountTaxCompensationAmount = new Fraction(0);
        this.customShipping = new Fraction(0);
        this.specialDiscountAmount = new Fraction(0);
        this.totalProduct = 0;
        this.totalQty = 0;
        this.totalCanceled = 0;
        this.totalInvoiced = 0;
        this.totalRefunded = 0;
        this.paymentMethodId = 0;
        this.shippingAmount = new Fraction(0);
        this.shippingDiscountAmount = new Fraction(0);
        this.shippingInclTax = new Fraction(0);
        this.shippingTaxAmount = new Fraction(0);
        this.shippingMethodDetail = '';
        this.globalToOrderRate = new Fraction(0);
        this.chainStoreId = '';
        this.shippingDiscountTaxCompensationAmount = 0;
        this.totalShippingAmount = 0;
        this.items = [];
    }
};
__decorate([
    IsNotEmpty(),
    autoserializeAs('orderId')
], OrderEntity.prototype, "orderId", void 0);
__decorate([
    IsNotEmpty(),
    autoserializeAs('storeId')
], OrderEntity.prototype, "storeId", void 0);
__decorate([
    autoserializeAs('cartId')
], OrderEntity.prototype, "cartId", void 0);
__decorate([
    autoserializeAs('mapOrderId')
], OrderEntity.prototype, "mapOrderId", void 0);
__decorate([
    autoserializeAs('orderToken')
], OrderEntity.prototype, "orderToken", void 0);
__decorate([
    autoserializeAs('appliedRuleIds')
], OrderEntity.prototype, "appliedRuleIds", void 0);
__decorate([
    autoserializeAs('couponCode')
], OrderEntity.prototype, "couponCode", void 0);
__decorate([
    autoserializeAs('appliedRules')
], OrderEntity.prototype, "appliedRules", void 0);
__decorate([
    autoserializeAs('couponRuleName')
], OrderEntity.prototype, "couponRuleName", void 0);
__decorate([
    autoserializeAs('status')
], OrderEntity.prototype, "status", void 0);
__decorate([
    autoserializeAs('customerId')
], OrderEntity.prototype, "customerId", void 0);
__decorate([
    IsNotEmpty(),
    autoserializeAs('name')
], OrderEntity.prototype, "name", void 0);
__decorate([
    IsEmail(),
    autoserializeAs('email')
], OrderEntity.prototype, "email", void 0);
__decorate([
    autoserializeAs('isArchived')
], OrderEntity.prototype, "isArchived", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'grandTotal')
], OrderEntity.prototype, "grandTotal", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'subtotal')
], OrderEntity.prototype, "subtotal", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'subtotalInclTax')
], OrderEntity.prototype, "subtotalInclTax", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'subtotalInvoiced')
], OrderEntity.prototype, "subtotalInvoiced", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'subtotalCanceled')
], OrderEntity.prototype, "subtotalCanceled", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'subtotalRefunded')
], OrderEntity.prototype, "subtotalRefunded", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'discountAmount')
], OrderEntity.prototype, "discountAmount", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'discountInvoiced')
], OrderEntity.prototype, "discountInvoiced", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'discountRefunded')
], OrderEntity.prototype, "discountRefunded", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'taxAmount')
], OrderEntity.prototype, "taxAmount", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'taxCanceled')
], OrderEntity.prototype, "taxCanceled", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'taxInvoiced')
], OrderEntity.prototype, "taxInvoiced", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'taxRefunded')
], OrderEntity.prototype, "taxRefunded", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'discountTaxCompensationAmount')
], OrderEntity.prototype, "discountTaxCompensationAmount", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'customShipping')
], OrderEntity.prototype, "customShipping", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'specialDiscountAmount')
], OrderEntity.prototype, "specialDiscountAmount", void 0);
__decorate([
    autoserializeAs('totalProducts')
], OrderEntity.prototype, "totalProduct", void 0);
__decorate([
    autoserializeAs('totalQty')
], OrderEntity.prototype, "totalQty", void 0);
__decorate([
    autoserializeAs('totalCanceled')
], OrderEntity.prototype, "totalCanceled", void 0);
__decorate([
    autoserializeAs('totalInvoiced')
], OrderEntity.prototype, "totalInvoiced", void 0);
__decorate([
    autoserializeAs('totalRefunded')
], OrderEntity.prototype, "totalRefunded", void 0);
__decorate([
    autoserializeAs('paymentMethodId')
], OrderEntity.prototype, "paymentMethodId", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'shippingAmount')
], OrderEntity.prototype, "shippingAmount", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'shippingDiscountAmount')
], OrderEntity.prototype, "shippingDiscountAmount", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'shippingInclTax')
], OrderEntity.prototype, "shippingInclTax", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'shippingTaxAmount')
], OrderEntity.prototype, "shippingTaxAmount", void 0);
__decorate([
    autoserializeAs('shippingMethodId')
], OrderEntity.prototype, "shippingMethodId", void 0);
__decorate([
    autoserializeAs('shippingMethodName')
], OrderEntity.prototype, "shippingMethodName", void 0);
__decorate([
    autoserializeAs('shippingMethodDetail')
], OrderEntity.prototype, "shippingMethodDetail", void 0);
__decorate([
    autoserializeAs('globalCurrencyCode')
], OrderEntity.prototype, "globalCurrencyCode", void 0);
__decorate([
    autoserializeAs('orderCurrencyCode')
], OrderEntity.prototype, "orderCurrencyCode", void 0);
__decorate([
    autoserializeAs(FractionSerializer, 'globalToOrderRate')
], OrderEntity.prototype, "globalToOrderRate", void 0);
__decorate([
    autoserializeAs('weight')
], OrderEntity.prototype, "weight", void 0);
__decorate([
    autoserializeAs(DateSerializer, 'expiredAt')
], OrderEntity.prototype, "expiredAt", void 0);
__decorate([
    autoserializeAs('chainStoreId')
], OrderEntity.prototype, "chainStoreId", void 0);
__decorate([
    autoserializeAs('chainStoreDetail')
], OrderEntity.prototype, "chainStoreDetail", void 0);
__decorate([
    autoserializeAs('channelId')
], OrderEntity.prototype, "channelId", void 0);
__decorate([
    autoserializeAs('orderRef')
], OrderEntity.prototype, "orderRef", void 0);
__decorate([
    autoserializeAs('rawData')
], OrderEntity.prototype, "rawData", void 0);
__decorate([
    autoserializeAs('remark')
], OrderEntity.prototype, "remark", void 0);
__decorate([
    autoserializeAs('isGrandTotalOverrode')
], OrderEntity.prototype, "isGrandTotalOverrode", void 0);
__decorate([
    autoserializeAs('meta')
], OrderEntity.prototype, "meta", void 0);
__decorate([
    autoserializeAs(DateSerializer, 'lastPrinted')
], OrderEntity.prototype, "lastPrinte", void 0);
__decorate([
    autoserializeAs('shippingDiscountTaxCompensationAmount')
], OrderEntity.prototype, "shippingDiscountTaxCompensationAmount", void 0);
__decorate([
    autoserializeAs('totalShippingAmount')
], OrderEntity.prototype, "totalShippingAmount", void 0);
__decorate([
    ValidateNested(),
    autoserializeAs(OrderItem, 'items')
], OrderEntity.prototype, "items", void 0);
OrderEntity = __decorate([
    inheritSerialization(DynamoBaseEntity)
], OrderEntity);
export { OrderEntity };
//# sourceMappingURL=orders.js.map