import { InCartService } from '../services/client';
import { OrderEntity } from './models/orders';
declare type EntityList = {
    count: number;
    items: OrderEntity[];
};
declare type QueryCondition = {
    pageSize?: number;
    currentPage?: number;
    sortDirection?: 'asc' | 'desc';
    groupBy?: string;
} & QueryKeywords;
declare type QueryKeywords = {
    [key: string]: string;
} | {};
export declare class OrderService extends InCartService {
    createOrder(storeId: string, order: Partial<OrderEntity>): Promise<OrderEntity>;
    list(storeId: string, condition?: QueryCondition): Promise<EntityList>;
    getOrderById(storeId: string, orderId: string): Promise<OrderEntity>;
    updateOrderByid(storeId: string, orderId: string, entity: Partial<OrderEntity>): Promise<EntityList>;
}
export {};
