import { InCartService } from './client';
import { InCartMeResponse } from './models/authAdmin';
import { InCartAccessTokenResponse } from './models/auth';
export declare class InCartAuthAdminService extends InCartService {
    /**
     *
     * @param overrideAuthenticationToken
     * @return User Admin Profile: { id, name, email }
     */
    me(): Promise<InCartMeResponse>;
    /**
     * Initiate Login request with email and password.
     *
     * Example usage:
     *
     * ```ts
     * import { Client, InCartAuthAdminService, getConfiguration } from 'incart-api-client'
     *
     * const client = new Client(getConfiguration('alpha'))
     * const auth = new InCartAuthAdminService(client)
     * const token = await auth.login('test@gmail.com', 'password')
     * client.overrideSession(token)
     * const me = await auth.me()
     * ```
     *
     * @param email
     * @param password
     * @returns AccessToken
     */
    login(email: string, password: string): Promise<InCartAccessTokenResponse>;
}
