import { AxiosInstance } from 'axios';
import { InCartAccessTokenResponse } from './models/auth';
export declare type InCartEnv = 'alpha' | 'qa' | 'prod' | 'A' | 'Q' | 'P';
export declare const isInCartEnv: (o: string) => o is InCartEnv;
export interface InCartConfig {
    apiKey: string;
    baseURL: string;
}
interface LogOption {
    requestPrefix: string;
    responsePrefix: string;
    errorPrefix: string;
}
export interface ClientLogger {
    log(...args: any[]): void;
    error(...args: any[]): void;
}
export declare class Client {
    readonly config: InCartConfig;
    readonly logger?: ClientLogger;
    private static _instances;
    static getInstance(config: InCartConfig): Client;
    private _axios;
    private _token?;
    get axios(): AxiosInstance;
    constructor(config: InCartConfig, logger?: ClientLogger, logOption?: LogOption);
    overrideSession(token: InCartAccessTokenResponse): void;
}
export declare class InCartService {
    readonly client: Client;
    constructor(client: Client);
    protected get axios(): AxiosInstance;
}
export {};
