var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var InCartProduct_1, MultipleLangInCartProduct_1;
import { autoserializeAs, inheritSerialization } from "cerialize";
import { LangPair } from "./base";
export class MinMaxValue {
    static zero() {
        const v = new MinMaxValue();
        v.min = 0;
        v.max = 0;
        return v;
    }
}
__decorate([
    autoserializeAs('min')
], MinMaxValue.prototype, "min", void 0);
__decorate([
    autoserializeAs('max')
], MinMaxValue.prototype, "max", void 0);
export class PriceFormat {
    constructor() {
        this.special = null;
    }
    static noNull(value) {
        const pf = new PriceFormat();
        if (!value) {
            pf.original = MinMaxValue.zero();
            pf.special = null;
            return pf;
        }
        pf.original = new MinMaxValue();
        pf.original.min = (value.original && value.original?.min) ?? value.original?.min ?? 0;
        pf.original.max = (value.original && value.original?.max) ?? value.original?.max ?? 0;
        pf.special = new MinMaxValue();
        pf.special.min = (value.special && value.special?.min) ?? value.special?.min ?? 0;
        pf.special.max = (value.special && value.special?.max) ?? value.special?.max ?? 0;
        return pf;
    }
}
__decorate([
    autoserializeAs(MinMaxValue, 'original')
], PriceFormat.prototype, "original", void 0);
__decorate([
    autoserializeAs(MinMaxValue, 'special')
], PriceFormat.prototype, "special", void 0);
export class Suggest {
}
__decorate([
    autoserializeAs('input')
], Suggest.prototype, "input", void 0);
__decorate([
    autoserializeAs('contexts')
], Suggest.prototype, "contexts", void 0);
export class LangsSuggest {
}
__decorate([
    autoserializeAs('en')
], LangsSuggest.prototype, "en", void 0);
__decorate([
    autoserializeAs('th')
], LangsSuggest.prototype, "th", void 0);
export class WareHouse {
}
__decorate([
    autoserializeAs('id')
], WareHouse.prototype, "id", void 0);
__decorate([
    autoserializeAs('name')
], WareHouse.prototype, "name", void 0);
__decorate([
    autoserializeAs('active')
], WareHouse.prototype, "active", void 0);
__decorate([
    autoserializeAs('created_at')
], WareHouse.prototype, "created_at", void 0);
__decorate([
    autoserializeAs('updated_at')
], WareHouse.prototype, "updated_at", void 0);
export class Inventory {
}
__decorate([
    autoserializeAs('qty')
], Inventory.prototype, "qty", void 0);
__decorate([
    autoserializeAs('stockType')
], Inventory.prototype, "stockType", void 0);
export class Warehouse {
    constructor() {
        this.active = false;
        this.updated_at = null;
    }
}
__decorate([
    autoserializeAs('id')
], Warehouse.prototype, "id", void 0);
__decorate([
    autoserializeAs('name')
], Warehouse.prototype, "name", void 0);
__decorate([
    autoserializeAs('active')
], Warehouse.prototype, "active", void 0);
__decorate([
    autoserializeAs('created_at')
], Warehouse.prototype, "created_at", void 0);
__decorate([
    autoserializeAs(Warehouse, 'updated_at')
], Warehouse.prototype, "updated_at", void 0);
export class ChannelWarehouses {
}
__decorate([
    autoserializeAs('id')
], ChannelWarehouses.prototype, "id", void 0);
__decorate([
    autoserializeAs('channelId')
], ChannelWarehouses.prototype, "channelId", void 0);
__decorate([
    autoserializeAs('warehouseId')
], ChannelWarehouses.prototype, "warehouseId", void 0);
__decorate([
    autoserializeAs('warehouse_id')
], ChannelWarehouses.prototype, "warehouse_id", void 0);
__decorate([
    autoserializeAs(Warehouse, 'warehouse')
], ChannelWarehouses.prototype, "warehouse", void 0);
export class Channel {
}
__decorate([
    autoserializeAs('id')
], Channel.prototype, "id", void 0);
__decorate([
    autoserializeAs('type')
], Channel.prototype, "type", void 0);
__decorate([
    autoserializeAs('name')
], Channel.prototype, "name", void 0);
__decorate([
    autoserializeAs('updatedAt')
], Channel.prototype, "updatedAt", void 0);
__decorate([
    autoserializeAs('createdAt')
], Channel.prototype, "createdAt", void 0);
__decorate([
    autoserializeAs(ChannelWarehouses, 'channel_warehouses')
], Channel.prototype, "channel_warehouses", void 0);
export class ProductRef {
}
__decorate([
    autoserializeAs('id')
], ProductRef.prototype, "id", void 0);
__decorate([
    autoserializeAs('productId')
], ProductRef.prototype, "productId", void 0);
__decorate([
    autoserializeAs('channelId')
], ProductRef.prototype, "channelId", void 0);
__decorate([
    autoserializeAs('name')
], ProductRef.prototype, "name", void 0);
__decorate([
    autoserializeAs('itemId')
], ProductRef.prototype, "itemId", void 0);
__decorate([
    autoserializeAs('variantId')
], ProductRef.prototype, "variantId", void 0);
__decorate([
    autoserializeAs('price')
], ProductRef.prototype, "price", void 0);
__decorate([
    autoserializeAs('specialPrice')
], ProductRef.prototype, "specialPrice", void 0);
__decorate([
    autoserializeAs('refType')
], ProductRef.prototype, "refType", void 0);
__decorate([
    autoserializeAs('channel_id')
], ProductRef.prototype, "channel_id", void 0);
__decorate([
    autoserializeAs(Channel, 'channel')
], ProductRef.prototype, "channel", void 0);
export class Stock {
}
__decorate([
    autoserializeAs('sku')
], Stock.prototype, "sku", void 0);
__decorate([
    autoserializeAs('indexId')
], Stock.prototype, "indexId", void 0);
__decorate([
    autoserializeAs('qty')
], Stock.prototype, "qty", void 0);
__decorate([
    autoserializeAs('productId')
], Stock.prototype, "productId", void 0);
__decorate([
    autoserializeAs('stockType')
], Stock.prototype, "stockType", void 0);
__decorate([
    autoserializeAs('warehouseId')
], Stock.prototype, "warehouseId", void 0);
__decorate([
    autoserializeAs('refillThresholdValue')
], Stock.prototype, "refillThresholdValue", void 0);
__decorate([
    autoserializeAs('updatedAt')
], Stock.prototype, "updatedAt", void 0);
export class Media {
}
__decorate([
    autoserializeAs('id')
], Media.prototype, "id", void 0);
__decorate([
    autoserializeAs('path')
], Media.prototype, "path", void 0);
__decorate([
    autoserializeAs('type')
], Media.prototype, "type", void 0);
__decorate([
    autoserializeAs('ref')
], Media.prototype, "ref", void 0);
__decorate([
    autoserializeAs('position')
], Media.prototype, "position", void 0);
export class StockReserve {
}
__decorate([
    autoserializeAs('orderId')
], StockReserve.prototype, "orderId", void 0);
__decorate([
    autoserializeAs('qty')
], StockReserve.prototype, "qty", void 0);
class BaseTaxonomy {
}
__decorate([
    autoserializeAs('id')
], BaseTaxonomy.prototype, "id", void 0);
let LocalizedTaxonomy = class LocalizedTaxonomy extends BaseTaxonomy {
};
__decorate([
    autoserializeAs('label')
], LocalizedTaxonomy.prototype, "label", void 0);
LocalizedTaxonomy = __decorate([
    inheritSerialization(BaseTaxonomy)
], LocalizedTaxonomy);
export { LocalizedTaxonomy };
let LangTaxonomy = class LangTaxonomy extends BaseTaxonomy {
};
__decorate([
    autoserializeAs(LangPair, 'label')
], LangTaxonomy.prototype, "label", void 0);
LangTaxonomy = __decorate([
    inheritSerialization(BaseTaxonomy)
], LangTaxonomy);
export { LangTaxonomy };
export class Brand {
    constructor() {
        this.label = null;
    }
}
__decorate([
    autoserializeAs('id')
], Brand.prototype, "id", void 0);
__decorate([
    autoserializeAs('label')
], Brand.prototype, "label", void 0);
__decorate([
    autoserializeAs('actualValue')
], Brand.prototype, "actualValue", void 0);
export class Badge {
}
__decorate([
    autoserializeAs('id')
], Badge.prototype, "id", void 0);
__decorate([
    autoserializeAs('label')
], Badge.prototype, "label", void 0);
__decorate([
    autoserializeAs('actualValue')
], Badge.prototype, "actualValue", void 0);
export class SubOptions {
}
__decorate([
    autoserializeAs('id')
], SubOptions.prototype, "id", void 0);
__decorate([
    autoserializeAs('label')
], SubOptions.prototype, "label", void 0);
__decorate([
    autoserializeAs('actualValue')
], SubOptions.prototype, "actualValue", void 0);
export class BaseOptions {
}
__decorate([
    autoserializeAs('attributeId')
], BaseOptions.prototype, "attributeId", void 0);
__decorate([
    autoserializeAs('type')
], BaseOptions.prototype, "type", void 0);
__decorate([
    autoserializeAs('code')
], BaseOptions.prototype, "code", void 0);
__decorate([
    autoserializeAs(LangPair, 'label')
], BaseOptions.prototype, "label", void 0);
__decorate([
    autoserializeAs(SubOptions, 'options')
], BaseOptions.prototype, "options", void 0);
let LocalizedOptions = class LocalizedOptions {
};
__decorate([
    autoserializeAs('label')
], LocalizedOptions.prototype, "label", void 0);
LocalizedOptions = __decorate([
    inheritSerialization(BaseOptions)
], LocalizedOptions);
export { LocalizedOptions };
let LangOptions = class LangOptions extends BaseOptions {
};
__decorate([
    autoserializeAs(LangPair, 'label')
], LangOptions.prototype, "label", void 0);
LangOptions = __decorate([
    inheritSerialization(BaseOptions)
], LangOptions);
export { LangOptions };
export class Attributes {
}
__decorate([
    autoserializeAs(BaseOptions, 'options')
], Attributes.prototype, "options", void 0);
export class PaymentMethods {
}
__decorate([
    autoserializeAs('id')
], PaymentMethods.prototype, "id", void 0);
__decorate([
    autoserializeAs('isBrandActive')
], PaymentMethods.prototype, "isBrandActive", void 0);
export class ToPage {
}
__decorate([
    autoserializeAs('pageId')
], ToPage.prototype, "pageId", void 0);
__decorate([
    autoserializeAs('labelTh')
], ToPage.prototype, "labelTh", void 0);
__decorate([
    autoserializeAs('labelEn')
], ToPage.prototype, "labelEn", void 0);
__decorate([
    autoserializeAs('sortOrder')
], ToPage.prototype, "sortOrder", void 0);
/* Raw product from inCart */
class BaseInCartProduct {
    // Not-relevant do not map.
    // @autoserializeAs('chainStore')
    // chainStore: object
    // @autoserializeAs(PaymentMethods, 'paymentMethods')
    // paymentMethods!: PaymentMethods[] | null
    // Not-relevant do not map.
    // @autoserializeAs('specialCondition')
    // specialCondition: object
    // Not-relevant do not map.
    // @autoserializeAs(ToPage, 'toPage')
    // toPage: ToPage[] | null
    constructor(from = null) {
        if (!from) {
            return;
        }
        this.id = from.id;
        this.sku = from.sku;
        this.storeId = from.storeId;
        this.type = from.type;
        this.width = from.width;
        this.weight = from.weight;
        this.height = from.height;
        this.length = from.length;
        this.media = from.media;
        this.visibility = from.visibility;
        this.status = from.status;
        this.createdAt = from.createdAt;
        this.updatedAt = from.updatedAt;
        this.price = PriceFormat.noNull(from.price);
        this.stock = from.stock;
        this.inventory = from.inventory;
        this.media = from.media;
        this.brand = from.brand;
        this.badge = from.badge;
        this.properties = from.properties;
        this.attributes = from.attributes;
        // this.paymentMethods = from.paymentMethods
    }
}
__decorate([
    autoserializeAs('id')
], BaseInCartProduct.prototype, "id", void 0);
__decorate([
    autoserializeAs('sku')
], BaseInCartProduct.prototype, "sku", void 0);
__decorate([
    autoserializeAs('storeId')
], BaseInCartProduct.prototype, "storeId", void 0);
__decorate([
    autoserializeAs('type')
], BaseInCartProduct.prototype, "type", void 0);
__decorate([
    autoserializeAs('width')
], BaseInCartProduct.prototype, "width", void 0);
__decorate([
    autoserializeAs('height')
], BaseInCartProduct.prototype, "height", void 0);
__decorate([
    autoserializeAs('length')
], BaseInCartProduct.prototype, "length", void 0);
__decorate([
    autoserializeAs('weight')
], BaseInCartProduct.prototype, "weight", void 0);
__decorate([
    autoserializeAs('visibility')
], BaseInCartProduct.prototype, "visibility", void 0);
__decorate([
    autoserializeAs('status')
], BaseInCartProduct.prototype, "status", void 0);
__decorate([
    autoserializeAs('createdAt')
], BaseInCartProduct.prototype, "createdAt", void 0);
__decorate([
    autoserializeAs('updatedAt')
], BaseInCartProduct.prototype, "updatedAt", void 0);
__decorate([
    autoserializeAs(PriceFormat, 'price')
], BaseInCartProduct.prototype, "price", void 0);
__decorate([
    autoserializeAs(Stock, 'stock')
], BaseInCartProduct.prototype, "stock", void 0);
__decorate([
    autoserializeAs(Inventory, 'inventory')
], BaseInCartProduct.prototype, "inventory", void 0);
__decorate([
    autoserializeAs(Media, 'media')
], BaseInCartProduct.prototype, "media", void 0);
__decorate([
    autoserializeAs('refillThresholdValue')
], BaseInCartProduct.prototype, "refillThresholdValue", void 0);
__decorate([
    autoserializeAs(Brand, 'brand')
], BaseInCartProduct.prototype, "brand", void 0);
__decorate([
    autoserializeAs(Badge, 'badge')
], BaseInCartProduct.prototype, "badge", void 0);
__decorate([
    autoserializeAs('properties')
], BaseInCartProduct.prototype, "properties", void 0);
__decorate([
    autoserializeAs(Attributes, 'attributes')
], BaseInCartProduct.prototype, "attributes", void 0);
let InCartProduct = InCartProduct_1 = class InCartProduct extends BaseInCartProduct {
    constructor(from = null) {
        super(from);
        if (!from) {
            return;
        }
        this.name = from.name;
        this.description = from.description;
        this.categories = from.categories;
        this.tags = from.tags;
        this.children = from.children;
    }
};
__decorate([
    autoserializeAs('name')
], InCartProduct.prototype, "name", void 0);
__decorate([
    autoserializeAs('description')
], InCartProduct.prototype, "description", void 0);
__decorate([
    autoserializeAs(LocalizedTaxonomy, 'categories')
], InCartProduct.prototype, "categories", void 0);
__decorate([
    autoserializeAs(LangTaxonomy, 'tags')
], InCartProduct.prototype, "tags", void 0);
__decorate([
    autoserializeAs(InCartProduct_1, 'children')
], InCartProduct.prototype, "children", void 0);
InCartProduct = InCartProduct_1 = __decorate([
    inheritSerialization(BaseInCartProduct)
], InCartProduct);
export { InCartProduct };
let MultipleLangInCartProduct = MultipleLangInCartProduct_1 = class MultipleLangInCartProduct extends BaseInCartProduct {
    constructor(from = null) {
        super(from);
        this.children = [];
        this.backInStockTimeStamp = 0;
        if (!from) {
            return;
        }
        this.name = from.name;
        this.description = from.description;
        this.categories = from.categories;
        this.tags = from.tags;
        this.children = from.children;
    }
};
__decorate([
    autoserializeAs('byStoreId')
], MultipleLangInCartProduct.prototype, "byStoreId", void 0);
__decorate([
    autoserializeAs(LangPair, 'name')
], MultipleLangInCartProduct.prototype, "name", void 0);
__decorate([
    autoserializeAs(LangPair, 'title')
], MultipleLangInCartProduct.prototype, "title", void 0);
__decorate([
    autoserializeAs(LangPair, 'description')
], MultipleLangInCartProduct.prototype, "description", void 0);
__decorate([
    autoserializeAs(LangTaxonomy, 'categories')
], MultipleLangInCartProduct.prototype, "categories", void 0);
__decorate([
    autoserializeAs(LangTaxonomy, 'tags')
], MultipleLangInCartProduct.prototype, "tags", void 0);
__decorate([
    autoserializeAs('codeColor')
], MultipleLangInCartProduct.prototype, "codeColor", void 0);
__decorate([
    autoserializeAs('colorSwatch')
], MultipleLangInCartProduct.prototype, "colorSwatch", void 0);
__decorate([
    autoserializeAs(MultipleLangInCartProduct_1, 'children')
], MultipleLangInCartProduct.prototype, "children", void 0);
__decorate([
    autoserializeAs(StockReserve, 'stockReserve')
], MultipleLangInCartProduct.prototype, "stockReserve", void 0);
__decorate([
    autoserializeAs('vizCoin')
], MultipleLangInCartProduct.prototype, "vizCoin", void 0);
__decorate([
    autoserializeAs('rawQty')
], MultipleLangInCartProduct.prototype, "rawQty", void 0);
__decorate([
    autoserializeAs('refillStock')
], MultipleLangInCartProduct.prototype, "refillStock", void 0);
__decorate([
    autoserializeAs('backInStockTimeStamp')
], MultipleLangInCartProduct.prototype, "backInStockTimeStamp", void 0);
MultipleLangInCartProduct = MultipleLangInCartProduct_1 = __decorate([
    inheritSerialization(BaseInCartProduct)
], MultipleLangInCartProduct);
export { MultipleLangInCartProduct };
export class Payloads {
}
__decorate([
    autoserializeAs(Stock, 'stocks')
], Payloads.prototype, "stocks", void 0);
__decorate([
    autoserializeAs('refillThresholdValue')
], Payloads.prototype, "refillThresholdValue", void 0);
__decorate([
    autoserializeAs('updatedAt')
], Payloads.prototype, "updatedAt", void 0);
export class PayloadStock {
}
__decorate([
    autoserializeAs(Payloads, 'payloads')
], PayloadStock.prototype, "payloads", void 0);
__decorate([
    autoserializeAs('storeId')
], PayloadStock.prototype, "storeId", void 0);
export class Products {
}
__decorate([
    autoserializeAs('id')
], Products.prototype, "id", void 0);
__decorate([
    autoserializeAs('sku')
], Products.prototype, "sku", void 0);
__decorate([
    autoserializeAs('stockType')
], Products.prototype, "stockType", void 0);
__decorate([
    autoserializeAs('qty')
], Products.prototype, "qty", void 0);
__decorate([
    autoserializeAs('type')
], Products.prototype, "type", void 0);
export class PayloadUpdateStockIncart {
}
__decorate([
    autoserializeAs(Products, 'products')
], PayloadUpdateStockIncart.prototype, "products", void 0);
__decorate([
    autoserializeAs('storeId')
], PayloadUpdateStockIncart.prototype, "storeId", void 0);
export class ReserveStock {
}
__decorate([
    autoserializeAs('sku')
], ReserveStock.prototype, "sku", void 0);
__decorate([
    autoserializeAs('storeId')
], ReserveStock.prototype, "storeId", void 0);
__decorate([
    autoserializeAs('orderId')
], ReserveStock.prototype, "orderId", void 0);
__decorate([
    autoserializeAs('qty')
], ReserveStock.prototype, "qty", void 0);
__decorate([
    autoserializeAs('indexId')
], ReserveStock.prototype, "indexId", void 0);
__decorate([
    autoserializeAs('returnStock')
], ReserveStock.prototype, "returnStock", void 0);
export class PayloadReserveStock {
}
__decorate([
    autoserializeAs(ReserveStock, 'payloads')
], PayloadReserveStock.prototype, "payloads", void 0);
//# sourceMappingURL=products.js.map