import { DefaultKeyValue, LangPair } from "./base";
declare class InCartPackageFeature {
    chats: boolean;
    clickAndCollect: boolean;
    creditTerms: boolean;
    customerTier: boolean;
    domain: boolean;
    orderManager: boolean;
    quotation: boolean;
    report: boolean;
    stockManage: boolean;
    syncMarketPlace: boolean;
    ordersLimit: number;
    productsLimit: number;
    staffsLimit: number;
    tier: number;
    type: string;
    id: string;
    name: string;
}
declare class InCartPackage {
    active: boolean;
    createdAt: Date;
    duration: string;
    id: string;
    name: string;
    paymentType: string;
    planId: string;
    price: number;
    updatedAt: Date;
    features: InCartPackageFeature;
}
export declare class InCartStorePackage {
    storeId: string;
    cycleDate: number;
    dueDate: Date;
    updatedAt: Date;
    packageId: string;
    package: InCartPackage;
}
export declare class InCartLocation {
    readonly storeId: string;
    constructor(storeId: string);
    baseURL: string;
    host: string;
    storeBaseURL: string;
    storeHost: string;
}
declare class InCartStoreCurrency {
    storeCurrency: DefaultKeyValue;
}
export declare class InCartStore {
    storeId: string;
    taxId: string;
    storeLogo: string;
    storeLogoMobile: string;
    favicon: string;
    storeName: LangPair;
    mobile: string;
    storeDescription: LangPair;
    currency: InCartStoreCurrency;
    timezone: DefaultKeyValue;
    constructor(storeId: string);
}
export declare class InCartStoreNameCandidateValidation {
    exist: boolean;
    storeId: string;
}
export {};
