var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { autoserializeAs } from "cerialize";
import { ISODateSerializer } from "../../utils/cerialize";
import { DefaultKeyValue, LangPair } from "./base";
class InCartPackageFeature {
    constructor() {
        this.chats = false;
        this.clickAndCollect = false;
        this.creditTerms = false;
        this.customerTier = false;
        this.domain = false;
        this.orderManager = false;
        this.quotation = false;
        this.report = false;
        this.stockManage = false;
        this.syncMarketPlace = false;
    }
}
__decorate([
    autoserializeAs('chats')
], InCartPackageFeature.prototype, "chats", void 0);
__decorate([
    autoserializeAs('clickAndCollect')
], InCartPackageFeature.prototype, "clickAndCollect", void 0);
__decorate([
    autoserializeAs('creditTerms')
], InCartPackageFeature.prototype, "creditTerms", void 0);
__decorate([
    autoserializeAs('customerTier')
], InCartPackageFeature.prototype, "customerTier", void 0);
__decorate([
    autoserializeAs('domain')
], InCartPackageFeature.prototype, "domain", void 0);
__decorate([
    autoserializeAs('orderManager')
], InCartPackageFeature.prototype, "orderManager", void 0);
__decorate([
    autoserializeAs('quotation')
], InCartPackageFeature.prototype, "quotation", void 0);
__decorate([
    autoserializeAs('report')
], InCartPackageFeature.prototype, "report", void 0);
__decorate([
    autoserializeAs('stockManage')
], InCartPackageFeature.prototype, "stockManage", void 0);
__decorate([
    autoserializeAs('syncMarketPlace')
], InCartPackageFeature.prototype, "syncMarketPlace", void 0);
__decorate([
    autoserializeAs('ordersLimit')
], InCartPackageFeature.prototype, "ordersLimit", void 0);
__decorate([
    autoserializeAs('productsLimit')
], InCartPackageFeature.prototype, "productsLimit", void 0);
__decorate([
    autoserializeAs('staffsLimit')
], InCartPackageFeature.prototype, "staffsLimit", void 0);
__decorate([
    autoserializeAs('tier')
], InCartPackageFeature.prototype, "tier", void 0);
__decorate([
    autoserializeAs('type')
], InCartPackageFeature.prototype, "type", void 0);
__decorate([
    autoserializeAs('id')
], InCartPackageFeature.prototype, "id", void 0);
__decorate([
    autoserializeAs('name')
], InCartPackageFeature.prototype, "name", void 0);
class InCartPackage {
}
__decorate([
    autoserializeAs('active')
], InCartPackage.prototype, "active", void 0);
__decorate([
    autoserializeAs('createdAt')
], InCartPackage.prototype, "createdAt", void 0);
__decorate([
    autoserializeAs('duration')
], InCartPackage.prototype, "duration", void 0);
__decorate([
    autoserializeAs('id')
], InCartPackage.prototype, "id", void 0);
__decorate([
    autoserializeAs('name')
], InCartPackage.prototype, "name", void 0);
__decorate([
    autoserializeAs('paymentType')
], InCartPackage.prototype, "paymentType", void 0);
__decorate([
    autoserializeAs('planId')
], InCartPackage.prototype, "planId", void 0);
__decorate([
    autoserializeAs('price')
], InCartPackage.prototype, "price", void 0);
__decorate([
    autoserializeAs(ISODateSerializer, 'updatedAt')
], InCartPackage.prototype, "updatedAt", void 0);
__decorate([
    autoserializeAs(InCartPackageFeature, 'features')
], InCartPackage.prototype, "features", void 0);
export class InCartStorePackage {
}
__decorate([
    autoserializeAs('storeId')
], InCartStorePackage.prototype, "storeId", void 0);
__decorate([
    autoserializeAs('cycleDate')
], InCartStorePackage.prototype, "cycleDate", void 0);
__decorate([
    autoserializeAs(ISODateSerializer, 'dueDate')
], InCartStorePackage.prototype, "dueDate", void 0);
__decorate([
    autoserializeAs(ISODateSerializer, 'updatedAt')
], InCartStorePackage.prototype, "updatedAt", void 0);
__decorate([
    autoserializeAs('packageId')
], InCartStorePackage.prototype, "packageId", void 0);
__decorate([
    autoserializeAs(InCartPackage, 'package')
], InCartStorePackage.prototype, "package", void 0);
export class InCartLocation {
    constructor(storeId) {
        this.storeId = storeId;
    }
}
__decorate([
    autoserializeAs('baseURL')
], InCartLocation.prototype, "baseURL", void 0);
__decorate([
    autoserializeAs('host')
], InCartLocation.prototype, "host", void 0);
__decorate([
    autoserializeAs('storeBaseURL')
], InCartLocation.prototype, "storeBaseURL", void 0);
__decorate([
    autoserializeAs('storeHost')
], InCartLocation.prototype, "storeHost", void 0);
class InCartStoreCurrency {
    constructor() {
        this.storeCurrency = new DefaultKeyValue('THB');
    }
}
__decorate([
    autoserializeAs(DefaultKeyValue, 'storeCurrency')
], InCartStoreCurrency.prototype, "storeCurrency", void 0);
export class InCartStore {
    constructor(storeId) {
        this.storeName = LangPair.empty();
        this.storeDescription = LangPair.empty();
        this.timezone = new DefaultKeyValue(7);
        this.storeId = storeId;
    }
}
__decorate([
    autoserializeAs('storeId')
], InCartStore.prototype, "storeId", void 0);
__decorate([
    autoserializeAs('taxId')
], InCartStore.prototype, "taxId", void 0);
__decorate([
    autoserializeAs('storeLogo')
], InCartStore.prototype, "storeLogo", void 0);
__decorate([
    autoserializeAs('storeLogoMobile')
], InCartStore.prototype, "storeLogoMobile", void 0);
__decorate([
    autoserializeAs('favicon')
], InCartStore.prototype, "favicon", void 0);
__decorate([
    autoserializeAs(LangPair, 'storeName')
], InCartStore.prototype, "storeName", void 0);
__decorate([
    autoserializeAs('mobile')
], InCartStore.prototype, "mobile", void 0);
__decorate([
    autoserializeAs(LangPair, 'storeDescription')
], InCartStore.prototype, "storeDescription", void 0);
__decorate([
    autoserializeAs(InCartStoreCurrency, 'currency')
], InCartStore.prototype, "currency", void 0);
__decorate([
    autoserializeAs(DefaultKeyValue, 'timezone')
], InCartStore.prototype, "timezone", void 0);
export class InCartStoreNameCandidateValidation {
}
__decorate([
    autoserializeAs('exist')
], InCartStoreNameCandidateValidation.prototype, "exist", void 0);
__decorate([
    autoserializeAs('storeId')
], InCartStoreNameCandidateValidation.prototype, "storeId", void 0);
//# sourceMappingURL=store.js.map