import { InCartService } from './client';
import { InCartPaymentOption, InCartShippingOption, InCartUpdateOrderAddressRequest, InCartListOrdersOption, InCartOrder, InCartOrderMeta, InCartOrderDetail } from './models/orders';
export declare class InCartOrdersService extends InCartService {
    updateOrderComment(storeId: string, orderId: string, comment: string, source: string, entityName: string): Promise<{
        success: boolean;
    }>;
    updateOrderStatus(storeId: string, orderId: string, status: string): Promise<{
        success: boolean;
    }>;
    updateOrderShipment(storeId: string, orderId: number, trackingNumber: string): Promise<{
        success: boolean;
    }>;
    cancelOrder(storeId: string, orderId: string): Promise<{
        success: boolean;
    }>;
    /**
     * Request estimate shipping cost along with available shipping options
     *
     * @param storeId
     * @param orderId
     */
    estimateShippingCost(storeId: string, orderId: number): Promise<{
        collection: InCartShippingOption[];
    }>;
    updateShippingMethod(storeId: string, orderId: number, shippingMethodId: number): Promise<void>;
    updateEmailOrMobile(storeId: string, orderId: number, emailOrMobile: string): Promise<boolean>;
    updateAddress(storeId: string, orderId: number, addressType: 'billing' | 'shipping', updateAddressRequest: InCartUpdateOrderAddressRequest): Promise<boolean>;
    /**
     * Unset billing address - mimic what Dashboard has updated.
     *
     * @param storeId
     * @param orderId
     * @return
     */
    removeBillingAddress(storeId: string, orderId: number): Promise<boolean>;
    updateShippingAddress(storeId: string, orderId: number, updateAddressRequest: InCartUpdateOrderAddressRequest): Promise<boolean>;
    updateBillingAddress(storeId: string, orderId: number, updateAddressRequest: InCartUpdateOrderAddressRequest): Promise<boolean>;
    listPaymentMethods(storeId: string, orderId: number): Promise<{
        collection: InCartPaymentOption[];
    }>;
    updatePaymentMethod(storeId: string, orderId: number, paymentMethodId: number): Promise<void>;
    listOrders(storeId: string, params: InCartListOrdersOption): Promise<{
        collection: InCartOrder[];
        meta: InCartOrderMeta;
    }>;
    listOrderDetail(storeId: string, orderId: number): Promise<InCartOrderDetail>;
}
