import { InCartService } from './client';
import { MultipleLangInCartProduct } from './models/products';
declare type InCartProductFields = 'id' | 'sku' | 'type' | 'width' | 'height' | 'weight' | 'visibility' | 'name' | 'status' | 'description' | 'price' | 'stock' | 'paymentMethods' | 'media' | 'categories' | 'tags' | 'brand' | 'badge' | 'metaDescritpion' | 'attributes' | 'properties' | 'speciaCondition' | 'children' | 'toPage' | 'chainStore' | 'metaKeywords' | 'productRef' | 'inventory' | 'createdAt' | 'updatedAt';
export declare const simpleInCartProductFields: InCartProductFields[];
interface FieldsLimitOption {
    pick: InCartProductFields[];
}
interface InCartProductQueryOption extends FieldsLimitOption {
    pageSize: number;
    currentPage: number;
    visibility: 'public' | 'all';
    checkStock: boolean;
    checkStatus: boolean;
    priceFrom: number;
    priceTo: number;
    sku: string[];
}
export interface InCartMasterProductQueryOptions {
    limit: number;
    offset: number;
    sortBy?: string;
    sortDirection?: string;
    keyword?: string;
    lastUpdate?: Date;
    traceId?: string;
}
export declare class InCartProductsService extends InCartService {
    list(storeId: string, queryOpt?: Partial<InCartProductQueryOption>): Promise<any>;
    listBySku(storeId: string, skus: string[], fieldOpt: FieldsLimitOption): Promise<any[]>;
    getBySku(storeId: string, sku: string): Promise<any>;
    getMasterProductsForSync(storeId: string, opts: InCartMasterProductQueryOptions): Promise<MultipleLangInCartProduct[]>;
}
export {};
