import { InCartService } from './client';
import { InCartLocation, InCartStore, InCartStoreNameCandidateValidation, InCartStorePackage } from './models/store';
export declare class InCartStoreService extends InCartService {
    /**
     * @param overrideAuthenticationToken
     * @return User Admin Profile: { id, name, email }
     */
    getStore(storeId: string): Promise<InCartStore>;
    getLocation(storeId: string): Promise<InCartLocation>;
    getPackage(storeId: string): Promise<InCartStorePackage>;
    /**
     * Validate if given store name exists?
     *
     * @param storeIdCandidate
     * @returns Status of candiate, or a new name if given store already exists.
     */
    validate(storeIdCandidate: string): Promise<InCartStoreNameCandidateValidation>;
}
