import Fraction from 'fraction.js';
export declare const BooleanSerializer: (trueValue: string, falseValue: string) => {
    Serialize(jsValue: boolean): string;
    Deserialize(jsonValue: string): boolean;
};
export declare const ISODateSerializer: {
    Serialize(jsValue: Date): string;
    Deserialize(jsonValue: string): Date;
};
export declare const JsonObjectToArraySerializer: <T>(cnstr: new (key: string | undefined) => T, serializeKey: (o: T) => string) => {
    Serialize(jsValue?: T[]): any;
    Deserialize(jsonValue: any): T[];
};
export declare const FractionSerializer: {
    Serialize(value: any): any;
    Deserialize(value: any): Fraction | null | undefined;
};
export declare const DateSerializer: {
    /**
     * dataValue => JSON data
     * @param dataValue
     * @returns number
     */
    Serialize(json?: string | Date | null): number | null;
    Deserialize(json: Date | string | number | null): Date | null;
};
