import { get } from 'lodash';
const configurations = {
    prod: {
        apiKey: '',
        baseURL: 'https://www.incart.co/',
    },
    qa: {
        apiKey: '',
        baseURL: 'https://qa.incart.co/',
    },
    alpha: {
        apiKey: '',
        baseURL: 'https://alpha.incart.co/',
    },
};
const serviceConfigurations = {
    incart: configurations,
    order: {
        qa: {
            baseURL: 'https://gd5ro7xmjk.execute-api.ap-southeast-1.amazonaws.com/qa/order/v1/',
            apiKey: '',
        },
        alpha: {
            baseURL: 'https://gd5ro7xmjk.execute-api.ap-southeast-1.amazonaws.com/qa/order/v1/',
            apiKey: '',
        },
    }
};
export const getConfiguration = (o, service, overrideApiKey) => {
    const configurations = getServiceConfiguration(service);
    const basic = () => {
        if (o === 'A' || o === 'alpha')
            return configurations.alpha;
        if (o === 'Q' || o === 'qa')
            return configurations.qa;
        if (o === 'P' || o === 'prod')
            return configurations.prod;
        throw new Error(`Unknown environment "${o}".`);
    };
    if (overrideApiKey) {
        return {
            ...basic(),
            apiKey: overrideApiKey
        };
    }
    return basic();
};
export const getServiceConfiguration = (service = 'incart') => {
    let serviceConfiguration;
    serviceConfiguration = get(serviceConfigurations, service);
    if (!serviceConfiguration) {
        throw new Error(`Unknown service "${service}".`);
    }
    return serviceConfiguration;
};
//# sourceMappingURL=config.js.map