export class RegEx {
    static matchOneOf(...values) { return new RegExp(`^(${values.join(',')})$`); }
    static replace0withCoutnryCode(mayBePhoneNumber, countryCode = '66') {
        // Is this phone number that start with leading 0?
        const noSpaceAndDash = mayBePhoneNumber.replace(/\s-/gi, '');
        if (/^0[0-9]{8,}$/.test(noSpaceAndDash)) {
            return noSpaceAndDash.replace(/^0/, `+${countryCode}`);
        }
        return mayBePhoneNumber;
    }
}
RegEx.email = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
RegEx.thaiMobileNumber = /^\+66[1-9]\d{8,}$/;
RegEx.latLongValue = /^\d{1,}\.\d{3,}$/;
RegEx.vatId = /^\d{10,}$/;
//# sourceMappingURL=regex.js.map